# AirPrice Reference Payload

The AirPrice API confirms pricing on air search results. While air pricing is generally an optional but recommended step, it is required for low cost carriers and some NDC carriers. This API uses a reference payload request, which sends identifiers from the Search API response. To use the AirPrice reference payload request, your initial Search request must send offersPerPage to invoke caching if that Search was journey-based (leg-based search results are always cached).

Endpoint: POST /air/price/offers/buildfromcatalogproductofferings
Version: 11.36.0
Security: bearerAuth

## Security:

  - `bearerAuth` (unknown)
    http bearer JWT

## Header parameters:

  - `travelportPlusSessionIdentifier` (string)
    travelportPlusSessionIdentifier used to maintain an established agency session

  - `TraceId` (string)
    Identifier used to correlate Air API invocations across a multi-call business flows.

  - `XAUTH_TRAVELPORT_ACCESSGROUP` (string)
    Identifies the Travelport access group with which the caller is associated

  - `TVP-PCC-Core` (string)
    Allows user to pass PCC instead of Access Group ID

## Request body:

  - `application/json` (unknown)
    AirPrice Reference Payload request payload.

## Request fields (application/json):

  - `@type` (string, required)
    Discriminator. No child classes
    Example: OfferQueryBuildFromCatalogProductOfferings

  - `PaymentCriteria` (object)
    Optional object to send the BIN/INN (IssuerIdentificationNumber) of the credit card to be used for payment; sending the BIN returns OB fees in the response  
Required when using Air Canada flight pass.

  - `PaymentCriteria.@type` (string, required)
    discriminator
    Example: PaymentCriteria

  - `PaymentCriteria.IssuerIdentificationNumber` (string)
    Required if PaymentCriteria sent; 6 to 16 characters inclusive are accepted.  
The BIN/IssuerIdentificationNumber (IIN) of the credit card to be used for payment and returning OB fees. OB fees are ticketing and form of payment (FOP) charges, including credit card fees. Returned in an instance of Price/PriceBreakdown/Fees/Fee with a feeCode of OB.  
For NDC carrier BA, you must send the complete 16-digit credit card number to return the surcharge amount.
    Example: 123456

  - `PaymentCriteria.PaymentCardCode` (string)
    A two character code for a credit card
    Example: VI

  - `PaymentCriteria.DocumentNumber` (array)

  - `PaymentCriteria.DocumentNumber.value` (string)
    Example: 1259900123456

  - `PaymentCriteria.DocumentNumber.documentIssuer` (string)
    Document issuer
    Example: BA

  - `PaymentCriteria.DocumentNumber.documentType` (string)
    Document type like EMD, MCO
    Enum: "EMD", "MCO", "Ticket", "TASF", "Invoice"

  - `PaymentCriteria.DocumentNumber.travelerIdentifierRef` (string)
    traveler identifier reference
    Example: traveler_1

  - `PaymentCriteria.DocumentNumber.name` (string)
    The name of the Traveler being referenced.
    Example: SMITH/JMR

  - `PaymentCriteria.DocumentNumber.passengerTypeCode` (string)
    The passenger type code of the Traveler being referenced.
    Example: ADT

  - `PaymentCriteria.DocumentNumber.id` (string)
    A locally referenced ID
    Example: id_1

  - `PaymentCriteria.DocumentNumber.description` (string)
    Descriptive text used to identify the contents of a target object
    Example: Descriptive text.

  - `PaymentCriteria.DocumentNumber.uris` (array)
    The URI used to GET the target object in another domain.
    Example: ["www.travelport.com/uri"]

  - `PaymentCriteria.FlightPass` (array)
    In Search API, for NDC flight pass bookings this is a required field and must reference the owner in PassengerCriteria. Only one permitted per Search request.
Required when using a flight pass to pay for an Air Canada NDC booking. Only one instance allowed. Refer to the [Air Canada Flight Pass](https://developer.travelport.com/docs/flights/ndc/ndc-guide-for-air-canada-flight-pass) section of the NDC Guide for more information

  - `PaymentCriteria.FlightPass.@type` (string, required)
    Discriminator. No child classes
    Example: FlightPass

  - `PaymentCriteria.FlightPass.accountNumber` (string, required)
    The flight pass account number.
    Example: 0140851633093

  - `PaymentCriteria.FlightPass.supplier` (string, required)
    The flight pass supplier code. AC is the only value accepted at this time.
    Example: AC

  - `PaymentCriteria.FlightPass.Description` (array)

  - `PaymentCriteria.FlightPass.TravelerIdentifierRef` (array)
    In Search, use the passengerCriteriaRef to reference the owner of the flightpass. This is a mandatory field for Search API.

  - `PaymentCriteria.FlightPass.TravelerIdentifierRef.value` (string)
    Example: traveler_001

  - `PaymentCriteria.FlightPass.TravelerIdentifierRef.id` (string)
    A locally referenced ID
    Example: id_001

  - `PaymentCriteria.FlightPass.TravelerIdentifierRef.description` (string)
    Descriptive text used to identify the contents of a target object
    Example: Descriptive Text

  - `PaymentCriteria.FlightPass.TravelerIdentifierRef.uris` (array)
    Uniform Resource Identifier
    Example: ["www.travelport.com/uri"]

  - `PaymentCriteria.agencyAccountInd` (boolean)
    If true, payment will be made by agency account
    Example: true

  - `PaymentCriteria.bspInd` (boolean)
    If true, payment will be made by BSP
    Example: true

  - `PaymentCriteria.cashInd` (boolean)
    If true, payment will be made by cash
    Example: true

  - `PaymentCriteria.invoiceInd` (boolean)
    If true, payment will be made by invoice
    Example: true

  - `BuildFromCatalogProductOfferingsRequest` (object)
    Used to reference Air Search requests, such as for a Next Leg, reference-payload Price and Add Offer, or other reference-based calls. Defines the identifiers and selections needed to continue a workflow from a preceding Search response, including the cached search result id and the chosen offer and product to carry forward into the next request.

  - `BuildFromCatalogProductOfferingsRequest.@type` (string, required)
    Discriminator. Child classes BuildFromCatalogProductOfferingsRequestAir, BuildFromCatalogProductOfferingsRequestAirSearch, and BuildFromCatalogProductOfferingsRequestAirChange
    Enum: "BuildFromCatalogProductOfferingsRequestAir"

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingsIdentifier` (object, required)
    Used to identify a cached Air Search result for subsequent reference-payload requests. Defines the transaction identifier returned from Search that is sent in later steps (such as Next Leg Search and other workflows) to reference a prior search response.  
The Search response does not return the CatalogProductOfferings/Identifier object if caching is not invoked with offersPerPage in the Search request. A subsequent reference payload request to those search results cannot be sent without caching and the CatalogProductOfferings/Identifier value.

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingsIdentifier.id` (string)
    Local identifier within a given message for this object.
    Example: cpo_1

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingsIdentifier.Identifier` (object)
    A globally unique identifier key often used to reference a given option (such as Pricing, Booking, Rules, or additional workflows) or to retrieve information (such as Hotel pagination).

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingsIdentifier.Identifier.value` (string)
    Unique offer identifier that can be sent in subsequent payload requests to reference this offer.
When used for reference flight calls, the CatalogProductOfferingsIdentifier will be the transaction identifier from the Search, Next Leg Search, or Flight Specific Search response in CatalogProductOfferings/Identifier/value.
If you choose to pull the CatalogProductOfferingsIdentifier from the Price response instead (OfferListResponse/Identifier/value), either full or reference payload, please note for subsequent Add Offer requests you must remove the _PC appended to the end of the value in the AirPrice response (e.g., change value: '93d2091d-3d04-48ab-8091-6ae1525f02ea_PC' to value: '93d2091d-3d04-48ab-8091-6ae1525f02ea').
When building an AirPrice or Add Offer reference payload request:
- Look for the CatalogProductOfferingIdentifier (ex: o1) in a Search response at CatalogProductOfferings/CatalogProductOffering/id or a Price response at OfferListResponse/OfferID/id.
- Look for the ProductIdentifier (ex: p0) in a Search response at CatalogProductOfferings/CatalogProductOffering/ProductBrandOptions/ProductBrandOffering/Product/productRef or from a Price response at OfferListResponse/OfferID/Product/id.

When returned from a workbench, this value is the system generated workbench identifier that must be sent in all subsequent requests for this workbench session.
When returned from Air Exchange Eligibility, value is the ticket number sent with the eligibility request.
When used specifically for form of payment, the value will begin with the characters 'FOP'. Similarly, the OfferIdentifier associated will begin with the character 'O'.
- If not available, for Payment, any unique identifier can be sent.

For Hotel Create Reservation (Reference Payload), send the value from the Availability response in CatalogOffering/id or the value from SearchComplete returned in propertyItems/lowestPublicAvailableRate/rateKey/value.
Results from Hotel Availability and Hotel SearchComplete are stored in the cache for 30 minutes. If the offers expire before booking, you must send a new request.
    Example: A0656EFF-FAF4-456F-B061-0161008D7C4E

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingsIdentifier.Identifier.authority` (string)
    Name of the supplier system that created this identifier - the source of information.  
For AirPrice, please note that GDS offers return the value 'Travelport' in authority while NDC offers return the carrier code of the issuing NDC carrier.  
When returned from Air Exchange Eligibility, authority is always 'Travelport' as the transaction issuer.  
For Hotels, authority indicates which supplier returned the lowest available rate for that property: either 'TVPT' (Travelport) or 'BKNG' (booking.com). Booking.com access requires additional provisioning and a direct agreement with the supplier. Authority is not returned if the property is closed or returns an error.  
For Hotel Create Reservation (Full Payload) and Sync Reservation send the value from the Availability response in CatalogOffering/Identifier/authority for the instance you want to book.
    Example: TVPT

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingSelection` (array, required)

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingSelection.@type` (string)
    Discriminator. No child classes.
    Example: CatalogProductOfferingSelection

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingSelection.CatalogProductOfferingIdentifier` (object, required)
    Top level object for offer identifier.

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingSelection.CatalogProductOfferingIdentifier.id` (string)
    Local identifier within a given message for this object.
    Example: cpo_1

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingSelection.CatalogProductOfferingIdentifier.CatalogProductOfferingRef` (string)
    Not used. Allows referencing another instance of this object in the same message.
    Example: cpo_1

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingSelection.ProductIdentifier` (array, required)
    A list of values used to reference specific products.

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingSelection.ProductIdentifier.id` (string)
    Local identifier within a given message for this object.
    Example: product_1

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingSelection.ProductIdentifier.productRef` (string)
    Used to reference another instance of this object in the same payload.
    Example: product_1

  - `BuildFromCatalogProductOfferingsRequest.CatalogProductOfferingSelection.SegmentSequence` (array)
    Example: [1,2]

  - `BuildFromCatalogProductOfferingsRequest.UpsellOfferingIdentifier` (array)
    Will not implement.

  - `BuildFromCatalogProductOfferingsRequest.UpsellOfferingIdentifier.id` (string)
    Local identifier within a given message for this object.
    Example: UpsellOffering

  - `BuildFromCatalogProductOfferingsRequest.UpsellOfferingIdentifier.CatalogProductOfferingRef` (string)
    Used to reference another instance of this object in the same message

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir` (object)
    A selection of Pricing Modifiers that can be used to influence the Price of an Offer.  
- For the AirPrice reference payload request, if any price modifiers were included in the preceding Search request and no price modifiers are sent in the AirPrice request, the cached price modifiers sent at Search are sent with the AirPrice request. If any price modifiers are sent in the AirPrice reference payload request, all cached Search modifiers are discarded and only the modifiers sent in that AirPrice request are used.  
- For the Add Offer request, you may optionally store fares with one or more pricing modifiers. If a pricing modifier is not added, the auto stored fare is added to the reservation. There is no change in the AirReservation response when pricing modifiers are requested. AirReservation applies modifiers from Add Offer and earlier steps as follows:
  - Modifiers sent in the Add Offer request (supported for both full and reference payload).
  - If no modifiers are sent in Add Offer, any pricing modifiers sent in AirPrice are applied.
  - If no modifiers were sent in AirPrice, or if AirPrice was not sent, any pricing modifiers sent in Search are applied.  

  GDS only; pricing modifiers not supported for NDC.  

  If the requested modifier does not have any fares associated with it, the workbench commit fails and returns the error message 'No Fare Found'. Pricing happens at commit, not at Add Offer.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.@type` (string, required)
    Discriminator. Child classes PricingModifiersAir and PricingModifersAirDetail
    Enum: "PricingModifiersAirDetail"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.currencyCode` (string)
    In an API request, send the currency type to return if you want to override the default currency specified with your PCC.
    Example: GBP

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection` (object)
    Requests the return of fare types including private fares (negotiated), public fares (published), or net fares (consolidator fares, or any negotiated wholesale price that is further marked up for sale to customers). May be used to request fares with specific restrictions, change, or refund options.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.@type` (string, required)
    Discriminator. Child class FareSelectionDetail.
    Enum: "FareSelectionDetail"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.fareType` (string)
    Defines the type of fares to return (only public fares, only private fares, only agency private fares, etc.). These can be combined.
The response identifies the type of fare returned for each Product in PassengerFlight/FlightProduct @fareType. Possible values in the response are AirlinePrivateFare, AgencyPrivateFare, NetFare, or PublicFare.
    Enum: "PublicFaresOnly", "PrivateFaresOnly", "AgencyPrivateFaresOnly", "AirlinePrivateFaresOnly", "PublicAndPrivateFares", "NetFaresOnly", "AllFares"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions` (object)
    Supports requesting only fares that meet certain refund criteria. GDS only; not supported for NDC. Search supports sending up to 12 refundability options. The following combinations are mutually exclusive; if sent, Search ignores them and returns a warning message: NonRefundable cannot also be sent with PartialRefund. Refundable cannot also be sent with ChangeOptions/changeTypes=PenaltyToChange

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.@type` (string, required)
    Discriminator. No child classes.
    Example: RefundOptions

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.refundTypes` (array, required)

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange` (object)
    Not currently supported. User can express a minimum and maximum Refund penalty range that will be included in the result set.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.@type` (string)
    Example: RefundPenaltyRange

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.Minimum` (object)
    Parent object when amount is applied as an Amount or a Percent.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.Minimum.@type` (string, required)
    Discriminator classes AmountPercentAmount or AmountPercentPercent
    Enum: "AmountPercentAmount", "AmountPercentPercent"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.Minimum.application` (string)
    Type of commission
    Enum: "Full", "Partial", "Non-paying", "No-show", "Adjustment", "Commissionable"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.Minimum.Amount` (object)
    A monetary amount, up to 4 decimal places. Decimal place must be included.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.Minimum.Amount.value` (number)
    The amount of a given currency.
    Example: 124.56

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.Minimum.Amount.code` (string)
    An ISO 4217 alpha character code (3 characters) that specifies a money unit.
    Example: USD

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.Minimum.Amount.minorUnit` (integer)
    Minor units are a mechanism for expressing the relationship between a major currency unit and its corresponding minor currency unit.  
It is the smallest unit of a given currency. For example; the smallest denomination in USD is the cent, which is 1/100 of a USD, and the minor unit value is 2. Not all currencies have a minor unit.
    Example: 2

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.Minimum.Amount.currencySource` (string)
    The system requesting or returning the currency code specified in the attribute
    Enum: "Supplier", "Charged", "Requested"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.Minimum.Amount.approximateInd` (boolean)
    If true, the currency amount has been converted from the original amount.  
For Air Exchange Eligibility, returned only if a currency is converted. If returned, the value is always true, indicating that the fee is approximate because of currency conversion.  
For Hotel Availability and Rules, true indicates this is a calculated value; false indicates this is the value returned by the property.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.RefundOptions.RefundPenaltyRange.Minimum.Percent` (number)
    Percent amount of commission
    Example: 20

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.ChangeOptions` (object)
    Supports requesting only fares that meet certain change criteria. GDS only; not supported for NDC. Search supports sending up to 12 changeability options. ChangeOptions.changeTypes=PenaltyToChange cannot be sent with RefundOptions.Refundable. If sent, Search ignores them and returns a warning message

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.ChangeOptions.@type` (string)
    Discriminator. No child classes.
    Example: ChangeOptions

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.ChangeOptions.changeTypes` (array, required)

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.ChangeOptions.ChangePenaltyRange` (object)
    Not currently supported. User can express a minimum and maximum Change penalty range that will be included in the result set

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.ChangeOptions.ChangePenaltyRange.@type` (string)
    Example: ChangePenaltyRange

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.FareQualifier` (array)

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.FareQualifier.value` (string)
    Deprecated - do not use. Replaced by FareQualiferString
    Enum: "Consolidator", "Government", "Marine", "Military", "Reward", "StandBy", "Staff", "Student", "Tour", "Youth", "VistFriendsAndRelatives"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.FareQualiferString` (array)
    Request specific private leisure fares.
Supported values vary by NDC carrier. For detailed NDC support by carrier, see [NDC Carrier Support](https://developer.travelport.com/docs/flights/ndc/ndc-guide#ndc-carrier-support) in the developer documentation.
This value is returned in FlightProduct.FareQualifierString if supplied by the airline. (Note the misspelling in request parameter)"
    Example: ["Tour"]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.validatingCarrier` (string)
    IATA code for a carrier to override any default validating carrier (the airline designator that the ticket is issued against).  
If the validating carrier code is not supported for an itinerary, the response returns the error Ticketing Agreement does not exist.  
If an invalid validating carrier code is sent in the request, the response returns the error Unknown Carrier.
    Example: KA

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.prohibitMinStayFaresInd` (boolean)
    - If true: returns only fares that do not require a minimum stay.
- If false (default behavior): allows minimum stay fares.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.prohibitMaxStayFaresInd` (boolean)
    - If true: returns only fares that do not require a maximum stay.
- If false (default behavior): allows maximum stay fares.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.refundableOnlyInd` (boolean)
    - If true: returns only fares that are fully refundable.
- If false (default behavior): allows fares that are not fully refundable
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.prohibitAdvancePurchaseFaresInd` (boolean)
    - If true, returns only fares that do not require advance purchase.
- If false (default behavior): allows fares with advance purchase restrictions.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.prohibitUnbundledFaresInd` (boolean)
    Supported for GDS Exchanges.
- If true, prevents unbundled fares.
- If false (default behavior): does not prevent unbundled fares.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareSelection.prohibitRefundableFaresInd` (boolean)
    This field is deprecated. Use RefundOptions for refundability options
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation` (object)
    Use to send account codes for negotiated fares or to send optional India GST SSR Remarks in GSTRegistrationNumber.  
For NDC supports corporate loyalty program and GST Information. This information is returned in TermsAndConditions.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.@type` (string, required)
    Discriminator. No child classes
    Example: OrganizationInformation

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.OrganizationIdentifier` (array)
    Array of account codes to return negotiated fares. The response returns an instance of TermsAndConditions/OrganizationInformation/OrganizationIdentifier for each account code sent.
When FareSelection/fareType=PrivateFaresOnly and an account code is sent in OrganizationIdentifier, AirPrice ignores the account code. Instead, AirPrice returns any private fares available for that market and a booking code for your PCC. This prevents the return of an error message when no specific fare has been filed for that account code.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.OrganizationIdentifier.value` (string)
    The value of the code to apply.
Note for AirSearch account codes:
- For GDS, up to 15 account codes are supported. Account codes are alphanumeric and must start with an alphabetic character.
  - When one account code is sent, it is applied to the entire journey.
  - An account code can be sent for each SearchCriteriaFlight. When multiple account codes are sent, the first account code is applied to the first SearchCriteriaFlight, the second account code is applied to the second SearchCriteriaFlight, etc.
- For NDC, one account code per carrier is supported
    Example: JBD123456

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.OrganizationIdentifier.supplier` (string)
    The IATA code for the airline on which the code is applicable.
    Example: AA

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.OrganizationIdentifier.organizationCodeType` (string)
    Sends a description for the OrganizationIdentifer value.  
For AirPrice, always send with a value of Account.
    Enum: "Account", "OrganizationLoyaltyProgram", "Tour", "TicketDesignator"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.OrganizationIdentifier.segmentSequenceList` (array)
    Returned in response when the code is applicable to a specified segment sequence
    Example: [1,2,3]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.OrganizationIdentifier.productRef` (array)
    Returned in response when the code is applicable to a specified product
    Example: ["product_1"]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.OrganizationIdentifier.accountCodeFaresOnlyInd` (boolean)
    GDS only; not supported for NDC. Not supported in Standalone Price.
Indicator to limit the fares returned to only fares filed for the specified account code.
- If true: Limits the fares returned to only fares filed for that account code; must send with one or more account codes in OrganizationIdentifier/value. If sending multiple account codes, send each instance with accountCodeFaresOnlyInd set to true.
- If false (default behavior): does not limit fares returned to any account code sent.

If an account code is sent without accountCodeFaresOnlyInd=true, the response includes any fares filed for that account code plus fares that are not specific to the account code.
If accountCodeFaresOnlyInd=true and no account code is sent, the indicator is ignored and the response returns all fares and a warning message that the request must include an account code.
Note the following when also requesting private fares only:
- FareSelection/fareType=PrivateFaresOnly and account code: Private fares are returned.
- FareSelection/fareType=PrivateFaresOnly, accountCodeFaresOnlyInd=true, and account code: Any private fares specific to that account code are returned if available. If no private fares exist for that account code, an error message is returned.

Note the following when also requesting net fares:
- FareSelection/fareType=NetFaresOnly and account code: Net fares are returned.
- FareSelection/fareType=NetFaresOnly, accountCodeFaresOnlyInd=true, and account code: Any net fares specific to that account code are returned if available. If no net fares exist for that account code, an error message is returned.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.GSTRegistrationNumber` (array)
    Send to add India GST (Goods and Services Tax) Special Service Requests. In this case country should be IND. Supported during book 'Add Offer' workflow.
See the [India GST SSRs](https://developer.travelport.com/docs/flights/guides/booking-and-reservations/remarks-and-service-requests#india-gst-ssr) in the Remarks & Service Requests Guide for important details.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.GSTRegistrationNumber.value` (string, required)
    The GST registered number for the business.
    Example: 07AAGFF2194N1Z1

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.GSTRegistrationNumber.telephone` (string, required)
    Business telephone number
    Example: 222-222-222

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.GSTRegistrationNumber.address` (string, required)
    Business address
    Example: 1122 sample trail, CO, USA, 21232

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.GSTRegistrationNumber.country` (string, required)
    IATA country code of the business.
    Example: IND

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.GSTRegistrationNumber.companyName` (string, required)
    Business name
    Example: Adecco

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.OrganizationInformation.GSTRegistrationNumber.email` (string, required)
    Business E-Mail address
    Example: sample@adecco.com

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.TaxExemption` (object)
    GDS only, not supported for NDC.
Use to mark some or all taxes as exempt.
Specify all taxes, only specific tax codes, or all taxes in specific countries.
Must include either allTaxesExemptInd OR both countries and taxCodes.
TaxExemption supports up to nine values for countries, taxCodes, or both combined. The response returns any exempt taxes with exemptInd=true and value=0.
For AirChange: specify up to five taxes to exempt during exchange search.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.TaxExemption.@type` (string)
    Discriminator. No child classes.
    Example: TaxExemption

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.TaxExemption.countries` (array)
    One or more ISO codes for the countries in which the paired taxCodes sent are tax exempt. Must also send taxCodes object.
    Example: ["GB","MX"]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.TaxExemption.taxCodes` (array)
    One or more two-letter alphanumeric tax codes to mark as exempt in the paired country. Must also send countries object.
For AirChange: send up to five tax codes to exempt. Exempted taxes are returned in the response as PriceBreakdown/Taxes/Tax/exemptInd=true.
    Example: ["US"]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.TaxExemption.allTaxesExemptInd` (boolean)
    Use to set all taxes as exempt.
- If true: marks all taxes on the itinerary as tax exempt.
- Do not send if false. Instead, use countries and taxCodes to specify which taxes to exempt.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.PromotionalCode` (array)

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.PromotionalCode.value` (string)
    The promotional code to apply
    Example: CDFRT

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.PromotionalCode.supplierCode` (string, required)
    The IATA code for the airline on which the promotional code is applicable.
    Example: AA

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.SellCity` (string)
    GDS only, not supported for NDC.
The IATA location code for a city. Overrides the sell city of the requester to specify an alternate sale location and return fares based on that location. The response returns pricing in the local currency for the specified sell city instead of the PCC's default currency.
    Example: NYC

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.TicketCity` (string)
    GDS only, not supported for NDC.
The IATA location code for a city. Overrides the ticketing city of the requester to specify an alternate ticket location and return fares based on that location; the response returns pricing in the local currency for the specified ticket city instead of the PCC's default currency.
    Example: NYC

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.PricingPCC` (string)
    GDS only, not supported for NDC.
Use to send a faring PCC for which a selective access or code group agreement exists between that PCC and the PCC associated with your account.
The following combinations of PricingPCC and FareSelection/fareType=PrivateFaresOnly return results as follows:
- PricingPCC sent and PrivateFaresOnly not requested: If a selective access or group agreement exists, both public and any available private fares are returned for the requesting and providing PCC.
  - If no selective access or group agreement exists, only public fares are returned.
- PricingPCC sent and PrivateFaresOnly is requested: If a selective access or group agreement exists that allows private fare access, only available private fares are returned for the requesting and providing PCC.
  - If no agreement exists, or if an agreement exists but does not allow private fares access, an error is returned.
    Example: 0BX3

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareBasisCodeOverride` (array)

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareBasisCodeOverride.value` (string)
    Example: YEE1Y

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareBasisCodeOverride.specificFlightCriteriaRefs` (array)
    Reference the specificFlightCriteria you want to override. If blank, all segments will be overridden.
    Example: ["s1","s2"]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.FareBasisCodeOverride.unpricedFlightSegmentRefs` (array)
    Reference the unpricedFlightSegment you want to override. If blank, all segments will be overridden.
    Example: ["up1","up2"]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.MultiPricingAgency` (array)
    GDS only; not supported for NDC.
Invokes Premium Flex Search POS feature. Send up to three PCCs to return offers for those point of sale agencies in addition to your provisioned PCC. If a you send more than 3 PCCs in MultiPricingAgency, only the first 3 are validated.
Must append /buildpremiumflexoptions to the endpoint. See [Premium Flex Search](https://developer.travelport.com/docs/flights/guides/flights-search-guide#premium-flex-search) in the developer documentation for usage and examples, and usage of the Accept header value to specify returning aggregated or streamed content.
If both PricingPCC and MultiPricingAgency are sent with PCCs, the PCC in PricingPCC is ignored.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.TicketingPCC` (string)
    GDS only, not supported for NDC.  
In an API request, overrides the ticketing PCC associated with your account to specify an alternate PCC and return fares based on that PCC.
    Example: 0XS4

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.CalculatedFareAdjustment` (object)
    Used in Exchange Search to modify the Price of the Fare. Discriminator classes CalculatedFareAdjustmentDiscount or CalculatedFareAdjustmentIncrease

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.CalculatedFareAdjustment.@type` (string, required)
    Enum: "CalculatedFareAdjustmentDiscount", "CalculatedFareAdjustmentIncrease"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.ManualFareAdjustment` (array)
    Send to manually adjust the base fare amount on all fares for a specific PTC.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.ManualFareAdjustment.@type` (string, required)
    Discriminator. Child classes ManualFareAdjustmentIncrease or ManualFareAdjustmentDiscount
    Enum: "ManualFareAdjustmentIncrease", "ManualFareAdjustmentDiscount"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.ManualFareAdjustment.passengerTypeCodes` (array)
    Send the PTC/s to be increased or decreased. This increases or discounts the fare for all passengers with the PTC/s. If not sent, ManualFareAdjustment applies to all PTCs.
    Example: ["ADT","CHD"]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.BrandPreference` (array)

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.BrandPreference.@type` (string, required)
    Discriminator. No child classes exist
    Example: BrandPreference

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.BrandPreference.brandTier` (integer)
    The brand tier
    Example: 1

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.BrandPreference.legSequence` (array)
    Correlates with legSequence in SearchCriteriaFlight
    Example: [1,2]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.includeSplitPaymentInd` (boolean)
    GDS only, not supported for NDC.
Split ticketing is available only for customers specifically provisioned for split ticketing. If your account is not configured for split ticketing, sending includeSplitPaymentInd returns a response without split ticket offers and a warning message.
Requests request split ticketing, which returns outbound and inbound one-way fares in addition to round trip options in the Search API response. This may result in lower fares than the same or similar round-trip itinerary.
- If true: requests split ticketing.
- If false (default behavior): split ticketing options are not returned.

When split ticketing is requested, the Search response returns offers in the following order:
- Outbound one-way offers - Inbound one-way offers -  Round trip offers

The response identifies all one-way outbound and inbound offers with CombinabilityCode j0. CombinabilityCode values for round trip offers start at j1 and increment by one for each offer.
Only the following are supported for split ticketing:
- Search (not supported for Next Leg Search or Flight Specific Search)
- Round-trip journey-based offerings ( isJourney header not sent or sent as true, or CustomResponseModifiersAir/SearchRepresentation not sent or sent with value Journey)
- Upsells.

Split ticketing is not supported for round-trip leg-based searches, virtual interlining, or NDC.
Split ticketing returns one-way outbound and one-way inbound fares in addition to round-trip offers. Split ticket offers are identified with CombinabilityCode j0.
In Air Price: for split ticketing the request must send offers that are identified in the Search response with CombinabilityCode j0, which identifies those offers as one-way outbound and one-way inbound split ticketing offers. A combination of j0 and any non-j0 value offer returns an error message that split pricing is not supported.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.returnMostRestrictiveBrandInd` (boolean)
    GDS only, not supported for NDC.
In Search API, when there are different brands on a connecting flight, return information for either the most restrictive brand or the brand on the most significant segment on the itinerary.
- If true: return the offer brand of the most restrictive brand.
- If false (default behavior): return the offer brand of the most significant segment of the itinerary.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.splitPaymentOfferings` (number)
    Number between 0 and 99. Send with includeSplitPaymentInd to configure the percentage of round trip offers to return in a split ticketing response.
By default, Search divides the split ticketing response into 34% round-trip offerings and the remainder as split ticketing offers, which are combined outbound and inbound one-way fares. To change this percentage, send splitPaymentOfferings with the percentage value of round trip offers to return.
    Example: 25

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand` (object)
    Information on airline Brand offerings.
If brand attributes were not excluded with inhibitBrandContentInd=true (GDS only), then brand attributes are returned and consolidated in ReferenceList/ReferenceListBrand. In this case Brand does not return the name or Identifier objects but instead returns only BrandRef, which matches to the brand identifier (e.g., b1) in ReferenceListBrand.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.@type` (string, required)
    Discriminator. Child classes BrandID and Brand. BrandCompleteInfo is no longer in use.
    Enum: "Brand"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.id` (string)
    Local id within a given message to support referencing this object.
    Example: brand_001

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.BrandRef` (string)
    Reference id that corresponds to the brand 'id' in ReferenceListBrand.Brand.
    Example: brandRef_001

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.name` (string, required)
    Brand name from the supplier.
    Example: Main Cabin Extra

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.tier` (integer)
    The brand tier. Not returned for NDC.
    Example: 2

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.shelfNumbers` (array)
    ATPCO shelf number. If the carrier has provided it for this brand, the shelf number is the number for a grouping of comparable brands that share similar ticket and flight attributes.
    Example: [1,4,5]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.code` (string)
    The ATPCO Brand Code.
    Example: REFMAIN

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.BrandAttribute` (array)
    A list of enumerated features that are included, chargeable, or not offered for this brand.  
Contains one or more instances of the two paired key value pairs classification and inclusion.  
The return of brand attributes can be disabled in the AirPrice Reference Payload request.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.BrandAttribute.@type` (string, required)
    Discriminator. No child classes.
    Example: BrandAttribute

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.BrandAttribute.classification` (string, required)
    The Travelport classification used for a category of ancillaries. Additional items can be sent in AdditionalClassification
    Enum: "CheckedBag", "CarryOn", "PersonalItem", "Rebooking", "Refund", "SeatAssignment", "PremiumSeat", "LieFlatSeat", "Meals", "WiFi", "Other"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.BrandAttribute.inclusion` (string, required)
    The indicator as to how the brand and the product are associated.
    Enum: "Included", "Chargeable", "Not Offered"

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.BrandAttribute.ImageURL` (array)
    URL for an image for the brand, when available.
    Example: ["http:/imageurl.com"]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.BrandAttribute.matchedAttributeInd` (boolean)
    Returned only if true for any attribute requested in ProductInclusionPreference.Classification.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.BrandAttribute.groupCode` (string)
    Carrier group code. Returned if filed by the carrier.
    Example: BG

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.BrandAttribute.subGroupCode` (string)
    Carrier sub group code. Returned if filed by the carrier.
    Example: CY

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.BrandAttribute.subCode` (string)
    Carrier sub code. Returned if filed by the carrier.
    Example: 08A

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.AdditionalBrandAttribute` (array)
    Array of non-enumerated features that are included, chargeable, or not offered for this brand. Contains one or more instances of the two paired key value pairs classification and inclusion.

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.AdditionalBrandAttribute.@type` (string, required)
    Discriminator. No child classes.
    Example: AdditionalBrandAttribute

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.AdditionalBrandAttribute.Classification` (string, required)
    The Travelport classification used for categories of ancillaries. Supported attributes currently include ChauffeurTransfer, ExtraLegroom, InFlightEntertainment, LoungeAccess, PriorityBaggage, PriorityBoarding, PriorityCheckIn, PrioritySecurity, PriorityServices,MileageAccrual, Upgrades, USB.
    Example: ChauffeurTransfer

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.AdditionalBrandAttribute.ImageURL` (array)
    URL for an image for the brand, when available.
    Example: ["https:/travelport/image/profile/firstviewimage"]

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.AdditionalBrandAttribute.matchedAttributeInd` (boolean)
    Returned only if true for any attribute requested in ProductInclusionPreference.Classification.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.AdditionalBrandAttribute.groupCode` (string)
    Carrier group code. Returned if filed by the carrier.
    Example: BG

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.AdditionalBrandAttribute.subGroupCode` (string)
    Carrier sub group code. Returned if filed by the carrier.
    Example: CY

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.AdditionalBrandAttribute.subCode` (string)
    Carrier sub code. Returned if filed by the carrier.
    Example: 08A

  - `BuildFromCatalogProductOfferingsRequest.PricingModifiersAir.Brand.ImageURL` (array)
    Example: ["http:/imageurl.com"]

  - `BuildFromCatalogProductOfferingsRequest.CabinPreference` (object)
    Requests a fare based on the cabin class. Only one cabin preferenceType (Permitted, Preferred, PreferredWithUpgrade) is allowed per request, but there is no limit to the number of cabins that can be sent.
- Any CabinPreference in the initial Search request is applied to any subsequent Next Leg Search and reference Flight Specific Search requests.
  - By default, the CabinPreference in the initial Search request is also applied to any subsequent Next Leg Search request. To override this default and return all cabins for the next leg in the response, send ignoreCabinPreferenceInd=true in the Next Leg Search request.
- In AirPrice and AirReservation (Supported for Full Payload path only)
- If CabinPreference was sent in the Search request, it is cached and sent with the AirPrice reference payload request. If CabinPreference is sent in the AirPrice request, all cached modifiers are discarded and only the modifiers sent in the AirPrice request are used.

Can be combined with lowFareFinderInd=true to return lowest fare in the requested cabin or cabins. When using CabinPreference and lowFareFinderInd, if both CabinPreference and a class of service are sent, class of service is ignored. If CabinPreference is sent without a class of service, the response returns the lowest fare in the cabin requested. If that cabin is not available, the response may upgrade or downgrade to a different cabin. If a different cabin than requested is returned, the response returns the message that the cabin class may differ from the class requested. If lowFareFinderInd=false and CabinPreference are sent in the request, AirPrice ignores the preferred cabin and returns a message that the preferred cabin was ignored.
If CabinPreference is set to All, no cabin preference is applied.

  - `BuildFromCatalogProductOfferingsRequest.CabinPreference.@type` (string, required)
    Discriminator. No child classes exist
    Example: CabinPreference

  - `BuildFromCatalogProductOfferingsRequest.CabinPreference.preferenceType` (string)
    Type of cabin preference.  
Sending a mix of preferenceType values is not supported. For example, you cannot send an instance of CabinPreference with a preferenceType of Permitted and another instance with preferenceType of Prohibited. In this case the results default to the Preferred preference.  
Note that if lowFareFinderInd is sent with true and CabinPreference is sent, the only supported value for CabinPreference/type is Permitted.
    Enum: "Preferred", "Permitted", "PreferredWithUpgrade", "Prohibited"

  - `BuildFromCatalogProductOfferingsRequest.CabinPreference.cabins` (array)
    A space-delimited list of cabins.

  - `BuildFromCatalogProductOfferingsRequest.CabinPreference.legSequence` (array)
    Leg level preference is supported only for CarrierPreference, CabinPreference, and ClassOfServicePreference. Not supported at AirPrice or Book.  
Limits preference to the specified leg.  You can apply the preference to only some legs of the itinerary, or different preferences to different legs. Best practice is to also send legSequence in SearchCriteriaFlight. To apply preference to the entire itinerary, do not send legSequence.
    Example: [1,2]

  - `BuildFromCatalogProductOfferingsRequest.FareRuleCategory` (array)
    Not recommended use. Invoke fare rule end points directly.

  - `BuildFromCatalogProductOfferingsRequest.FareRuleType` (string)
    Use not recommended; request fare rules using the Fare Rules API request instead.
Returns fare rules in the offer response.
Structured rules limit the rules returned to one or more of these categories: advance reservation/ticketing requirements, minimum/maximum stay, stopovers, penalties, voluntary exchanges and refunds.
GDS supports all categories; NDC supports only penalties. See the [Fare Rules Guide](https://developer.travelport.com/docs/flights/guides/fare-rules-guide) for details. Note that even if fare rules are not requested, for GDS only, change and cancel penalties are returned unless suppressed by sending CustomResponseModifiersAir/excludePenaltiesInd set to true.
Not supported in BuildOptions (Flight Specific Search).
    Enum: "Structured", "ShortText", "LongText"

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir` (object)
    Contains additional modifiers to customize the result set. Includes optional indicators for returning or excluding specified response content.  
Values sent at Search can carry forward into the Next Leg Search request and are not re-sent.

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.@type` (string, required)
    discriminator
    Example: CustomResponseModifiersAir

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.BrandAttributeInclusion` (array)
    Supported in AirSearch and AirPrice. Returns only information about the brand attributes specified and does not return any other brand attributes.

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.BrandAttributeInclusion.@type` (string)
    Example: BrandAttributeInclusion

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.BrandAttributeInclusion.legSequence` (array)
    Leg sequence not supported for BrandAttributeInclusion.
    Example: [1,2]

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.BrandAttributeInclusion.Classification` (array)
    Send one or more of the supported values to return information about only the specified attributes. Fares may include other attributes but information about them is not returned.

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.BrandAttributeInclusion.AdditionalClassification` (array)
    Send one or more of the additional supported values to return information about only the specified additional attributes.
Supported values:
- ChauffeurTransfer
- ExtraLegroom
- InFlightEntertainment
- LoungeAccess
- PriorityBaggage
- PriorityBoarding
- PriorityCheckIn
- PrioritySecurity
- PriorityServices
- MileageAccrual
- Upgrades
- USB

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.SearchRepresentation` (string)
    Specifies either a journey or leg-based response.This setting does not affect one-way itineraries, which have one leg and are always journey-based.
- Journey returns offers for all legs of the itinerary. Journey is the default.
- Leg returns offers for only the first leg of the itinerary. Must be followed with a Next Leg Search to select an offer for the first leg and return offers on the subsequent leg to combine with it.

Customize search result set as leg or journey based. Next Leg Search requests, and Flight Specific Search requests for less than the full itinerary, are supported only after a leg-based Search, not a journey-based Search. If these requests follow a journey-based Search request, an error message is returned.
    Enum: "Leg", "Journey", "LegWithJourneyData"

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.excludePenaltiesInd` (boolean)
    GDS only; not supported for NDC.
Indicator to omit change and cancel penalties.
- If true: omits all penalty information from the response.
- If false (default behavior): returns any change and penalty details provided by carrier for each offer in TermsAndConditionsFullAir/Penalties.

If sent in Search but not in AirPrice, the value sent in Search is cached and applied to the AirPrice results. However, you can override the value sent in Search by sending excludePenaltiesInd in the AirPrice request with the opposite value. For example, if the Search request sends excludePenaltiesInd=true and the AirPrice request sends excludePenaltiesInd=false, the Search response does not return penalties and the AirPrice response does return penalties.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.excludeBaggageFeesInd` (boolean)
    GDS only; not supported for NDC.
Indicator to exclude baggage details.
- If true: excludes baggage fees, carry on fees, and embargo information from the response. Baggage quantity or weight is returned instead.
- If false (default behavior): baggage details returned in response. Default is false.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.includeFareCalculationInd` (boolean)
    GDS only; not supported for NDC or in the Flight Specific Search full payload request.
Indicator to request the return of the fare calculation ladder.
- If true: returns the fare calculation ladder in BestCombinablePrice.PriceBreakdownAir.FareCalculation.
- If false (default behavior): fare calculation ladder is not returned.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.excludeSurchargesInd` (boolean)
    GDS only; not supported for NDC.
Indicator to exclude a surcharge breakdown.
- If true: excludes a surcharge breakdown from the response. Baggage quantity or kilos is returned instead.
- If false (default behavior): surcharge breakdown returned in response.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.excludeUnbundledFaresInd` (boolean)
    GDS only, not supported for NDC.
Sets whether to return unbundled fares. Supported in AirSearch and AirPrice.
- If true: does not return unbundled fares.
- If false (default behavior): returns unbundled and bundled fares as available.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.includeCO2EmissionsDataInd` (boolean)
    Indicator to return CO2 emission data in the Search and Next Leg Search responses.
- If true: returns CO2 emission data.
- If false (default behavior): CO2 emission data not returned.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.includeFlightAmenitiesInd` (boolean)
    Indicator to return flight amenities from ATPCO RouteHappy data.
- If true: includes amenities in the response if available.
- If false: Does not return ATPCO RouteHappy amenities.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.includeUniversalProductAttributesInd` (boolean)
    Indicator to return universal product attributes (UPAs), which include images, icons, and URLs as provided by ATPCO. Must also send includeFlightAmenitiesInd=true.
- If true: returns universal product attributes if available.
- If false (default behavior): Universal product attributes not returned.

UPAs are not returned for direct flights with intermediate stops, non-flight segments such as trains, or for Premium Business class.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.includeBundledAncillariesInd` (boolean)
    NDC only; not supported for GDS.  
If true: request NDC offers that include an ancillary service bundled with the cost of the air fare. This could be a discounted paid seat or any other ancillary service offered by the carrier.  
Search and Price responses will contain both ProductAir and ProductAncillary plus a new child class of PriceBreakdown, PriceBreakdownAncillaryAir, to define the ancillary inclusion and pricing.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.CustomResponseModifiersAir.includeFullPenaltyDisclosureInd` (boolean)
    GDS only. For NDC, change and cancel penalties are returned by the NDC carrier.
Indicator to return ATPCO Cat31 and Cat33 penalties in the response in TermsAndConditions/Penalties in Change and Cancel.
- If true: returns penalty information sourced from ATPCO Cat 31 and 33. Penalties may be exposed at fare component level and include time windows.
- If false (default behavior): Cat 31 and 33 penalties are not returned. The most restrictive Cat 16 penalties are returned.
When specified in the Search request, this indicator is applied to Reference Payload Flight Specific Search as well.

  - `BuildFromCatalogProductOfferingsRequest.lowFareFinderInd` (boolean)
    GDS only; not supported for NDC.
Provides pricing flexibility around class of service. If not sent, the response returns fares only in the requested class of service.
- If true: returns the lowest fares available in any class of service available, which may not be the same as the requested class. Note that if lowFareFinderInd is sent with true and CabinPreference is sent, the only supported value for CabinPreference/type is Permitted.
- If false: Provides fares for only the specified class of service. Default.

When lowFareFindInd=true and brand attributes are not disabled (inhibitBrandContentInd), AirPrice uses only the brand tier (and any other pricing modifiers) to find the lowest fare within a brand tier regardless of class of service.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.reCheckInventoryInd` (boolean)
    If true, verifies availability for the requested number of passengers in a specific class of service at the time of the price request by booking and releasing seats. Because this indicator temporarily affects seat availability, the recommended best practice is to use validateInventoryInd instead. Some airlines monitor for high volumes of sell/ignore transactions. Regardless of pricing results, air fares and inventory are only guaranteed by airlines when ticketed and paid. Can help reduce sell failures at booking by alerting of insufficient availability. If any or all segments are not bookable, AirPrice does not return any offers and returns an error message. GDS only, not supported for NDC (NDC carriers always validate inventory at pricing).
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.inhibitBrandContentInd` (boolean)
    If true, disables the return of branded fare attributes. By default the AirPrice Reference Payload request returns branded fare attributes.
    Example: true

  - `BuildFromCatalogProductOfferingsRequest.validateInventoryInd` (boolean)
    Verifies availability and may reduce failures at the Add Offer and Workbench Commit steps. If true, verifies availability for the requested number of passengers in a specific class of service at the time of the price request. If there are fewer seats than requested passengers available in that class of service, AirPrice returns an error message and no offers. GDS only, not supported for NDC (NDC carriers always validate inventory at pricing).
    Example: true

  - `MaxNumberOfUpsellsToReturn` (integer)
    NDC only; not supported for GDS.
Supports values from 0 to 99 inclusive. Send to request upsell offers along with pricing for the requested class of service or cabin, returned in ascending price order. An upsell is the next highest fare in a different brand or cabin than requested.
Upsells are returned as follows:
- If upsells not requested: Only the requested offer is returned.
- If one upsell requested: The lowest priced offer in the requested class of service or cabin plus one upsell offer are returned.
- If two or more upsells requested: The lowest priced offer in the requested class of service or cabin plus the requested number of upsell offers are returned.
    Example: 4

## Request examples:

  - `NDC request with organization information - account code` (unknown)

  - `NDC with SellCity pricing modifier` (unknown)

  - `OB fees charged based on credit card BIN` (unknown)

  - `NDC with CustomerLoyalty` (unknown)

## Response 200:

  - `200` (unknown)
    OK - Successful Response - 200

## Response 200 fields (application/json):

  - `OfferListResponse` (object)
    The response of an Offer list endpoint request, such as AirPrice and Add Offer calls.  
Defines one or more air offers returned including the offer identifiers and related response data needed for subsequent booking steps.

  - `OfferListResponse.@type` (string)
    Example: response

  - `OfferListResponse.transactionId` (string)
    A unique system-generated (128 bit GUID format) transaction/tracking id for a single request and response (i.e. for a single transaction) used for internal tracking and troubleshooting.  
Also known as E2ETrackingId.  
Not returned in all Hotel API responses.
    Example: 49f58f5f-c443-43b4-9f5d-be405fd00a01

  - `OfferListResponse.traceId` (string)
    Used in hospitality workflows to provide a unique transaction or tracking id for a single request and response.  
For Air Eligibility, returned if a custom trace ID was sent in the request header.  
For Hotel Rules, returned if a custom trace ID was sent in the request header.
    Example: TraceID_123456

  - `OfferListResponse.correlationId` (string)
    Identifier used to correlate hotel API invocations across a multi-call business flows.
    Example: 49f58f5f-c443-43b4-9f5d-be405fd00a01

  - `OfferListResponse.reservationStatus` (string)
    Status of reservation or offer completion.
    Enum: "Success", "Fail", "Partial", "Pending", "OnHold", "Retry", "Other"

  - `OfferListResponse.Result` (object)
    Returns the error and/or warning message information, if applicable.
See [Error Messaging](https://developer.travelport.com/docs/flights/general/error-messaging) for additional details.

  - `OfferListResponse.Result.@type` (string)
    Discriminator class Result only
    Example: Result

  - `OfferListResponse.Result.status` (string)
    The status of an error or warning
    Enum: "Not processed", "Incomplete", "Complete", "Unknown"

  - `OfferListResponse.Result.Error` (array)
    A list of error information returned at the provider level for a response.

  - `OfferListResponse.Result.Error.@type` (string, required)
    Discriminator classes Error or ErrorDetail
    Enum: "ErrorDetail"

  - `OfferListResponse.Result.Error.StatusCode` (integer)
    Http standard response code
    Example: 200

  - `OfferListResponse.Result.Error.Message` (string)
    The Travelport standardized error or warning message
    Example: No flights found.

  - `OfferListResponse.Result.Error.NameValuePair` (array)

  - `OfferListResponse.Result.Error.NameValuePair.value` (string)
    Text directly related to name description, providing more detail. May have character restrictions based on remark type (e.g. Free Text limitations: 84 characters, alphanumeric and some special characters).
    Example: Sunday

  - `OfferListResponse.Result.Error.NameValuePair.id` (string)
    Optional internally referenced id
    Example: 6

  - `OfferListResponse.Result.Error.NameValuePair.name` (string, required)
    Key, categorizing the type of remark or error.
    Example: Day1

  - `OfferListResponse.Result.Error.category` (string)
    A category to assist in identifying the error
    Example: VALIDATION

  - `OfferListResponse.Result.Error.SourceID` (string)
    The identifier of the source system sending the error or warning
    Example: 1G

  - `OfferListResponse.Result.Error.SourceCode` (string)
    The error or warning code returned by the source airline or host system
    Example: 1234

  - `OfferListResponse.Result.Error.SourceDescription` (string)
    The error or warning message as it is returned by the source airline or host system

  - `OfferListResponse.Result.Warning` (array)
    A list of warning information returned at the provider level for a response.

  - `OfferListResponse.Result.Warning.@type` (string, required)
    Discriminator classes Warning or WarningDetail
    Enum: "WarningDetail"

  - `OfferListResponse.Result.Warning.StatusCode` (integer)
    Http standard response code
    Example: 200

  - `OfferListResponse.Result.Warning.Message` (string)
    The Travelport standardized error or warning message
    Example: Customer Loyalty could not be applied.

  - `OfferListResponse.Result.Warning.NameValuePair` (array)

  - `OfferListResponse.Result.Warning.category` (string)
    A category to assist in identifying the error
    Example: INFORMATION

  - `OfferListResponse.Result.Warning.SourceID` (string)
    The identifier of the source system sending the error or warning
    Example: 1G

  - `OfferListResponse.Result.Warning.SourceCode` (string)
    The error or warning code returned by the source airline or host system
    Example: 1234

  - `OfferListResponse.Result.Warning.SourceDescription` (string)
    The error or warning message as it is returned by the source airline or host system

  - `OfferListResponse.Identifier` (object)
    A globally unique identifier key often used to reference a given option (such as Pricing, Booking, Rules, or additional workflows) or to retrieve information (such as Hotel pagination).

  - `OfferListResponse.Identifier.value` (string)
    Unique offer identifier that can be sent in subsequent payload requests to reference this offer.
When used for reference flight calls, the CatalogProductOfferingsIdentifier will be the transaction identifier from the Search, Next Leg Search, or Flight Specific Search response in CatalogProductOfferings/Identifier/value.
If you choose to pull the CatalogProductOfferingsIdentifier from the Price response instead (OfferListResponse/Identifier/value), either full or reference payload, please note for subsequent Add Offer requests you must remove the _PC appended to the end of the value in the AirPrice response (e.g., change value: '93d2091d-3d04-48ab-8091-6ae1525f02ea_PC' to value: '93d2091d-3d04-48ab-8091-6ae1525f02ea').
When building an AirPrice or Add Offer reference payload request:
- Look for the CatalogProductOfferingIdentifier (ex: o1) in a Search response at CatalogProductOfferings/CatalogProductOffering/id or a Price response at OfferListResponse/OfferID/id.
- Look for the ProductIdentifier (ex: p0) in a Search response at CatalogProductOfferings/CatalogProductOffering/ProductBrandOptions/ProductBrandOffering/Product/productRef or from a Price response at OfferListResponse/OfferID/Product/id.

When returned from a workbench, this value is the system generated workbench identifier that must be sent in all subsequent requests for this workbench session.
When returned from Air Exchange Eligibility, value is the ticket number sent with the eligibility request.
When used specifically for form of payment, the value will begin with the characters 'FOP'. Similarly, the OfferIdentifier associated will begin with the character 'O'.
- If not available, for Payment, any unique identifier can be sent.

For Hotel Create Reservation (Reference Payload), send the value from the Availability response in CatalogOffering/id or the value from SearchComplete returned in propertyItems/lowestPublicAvailableRate/rateKey/value.
Results from Hotel Availability and Hotel SearchComplete are stored in the cache for 30 minutes. If the offers expire before booking, you must send a new request.
    Example: A0656EFF-FAF4-456F-B061-0161008D7C4E

  - `OfferListResponse.Identifier.authority` (string)
    Name of the supplier system that created this identifier - the source of information.  
For AirPrice, please note that GDS offers return the value 'Travelport' in authority while NDC offers return the carrier code of the issuing NDC carrier.  
When returned from Air Exchange Eligibility, authority is always 'Travelport' as the transaction issuer.  
For Hotels, authority indicates which supplier returned the lowest available rate for that property: either 'TVPT' (Travelport) or 'BKNG' (booking.com). Booking.com access requires additional provisioning and a direct agreement with the supplier. Authority is not returned if the property is closed or returns an error.  
For Hotel Create Reservation (Full Payload) and Sync Reservation send the value from the Availability response in CatalogOffering/Identifier/authority for the instance you want to book.
    Example: TVPT

  - `OfferListResponse.NextSteps` (object)
    Container for the steps that describe actions that may be taken on the containing object.  
Not applicable for an Eligibility or Exchange response.

  - `OfferListResponse.NextSteps.baseURI` (string, required)
    The base portion of the URI in order to shorten the uris in the individual steps
    Example: www.travelport.com

  - `OfferListResponse.NextSteps.id` (string)
    Optional internally referenced id
    Example: 5

  - `OfferListResponse.NextSteps.NextStep` (array, required)

  - `OfferListResponse.NextSteps.NextStep.value` (string)
    Example: www.resourcelocation.com

  - `OfferListResponse.NextSteps.NextStep.id` (string)
    Identifier for the Next Step
    Example: 2

  - `OfferListResponse.NextSteps.NextStep.action` (string, required)
    The action this next step is intended to achieve
    Example: cancel

  - `OfferListResponse.NextSteps.NextStep.method` (string, required)
    Describes the set of potential methods that can be taken after an operation.
    Enum: "GET", "DELETE", "PUT", "POST"

  - `OfferListResponse.NextSteps.NextStep.description` (string)
    Additional clarification for the next step
    Example: remove offer from the order

  - `OfferListResponse.ReferenceList` (array)

  - `OfferListResponse.ReferenceList.@type` (string, required)
    Discriminator
- Air Search child classes are ReferenceListAmenity, ReferenceListBrand, ReferenceListFlight, ReferenceListProduct, ReferenceListTermsAndConditions, and ReferenceListUniversalProductAttribute.
- Air Price child classes are ReferenceListAmenity and ReferenceListBrand.
- FareRules child class is ReferenceListFlight.
- Search Ancillaries child class is ReferenceListFlight.
- Seat Map child class is ReferenceListSeatingChart.
- Hotel Availability child class is ReferenceListPropertyDates.
- Reservation and Reservation Workbench child classes are ReferenceListAmenity, ReferenceListBrand, and ReferenceListUniversalProductAttribute.
- Exchange Search child classes are ReferenceListBrand, ReferenceListFlight, and ReferenceListExchangedPrice.
- Reservation Receipt child classes are ReferenceListOffer and ReferenceListTraveler.
- Book_Traveler child class is ReferenceListTraveler.
    Enum: "ReferenceListSeatingChart", "ReferenceListFlight", "ReferenceListAmenity", "ReferenceListProduct", "ReferenceListTraveler", "ReferenceListOffer", "ReferenceListBrand", "ReferenceListTermsAndConditions", "ReferenceListExchangedPrice"

  - `OfferListResponse.ReferenceList.id` (string)
    Uniquely identifies for the Reference List
    Example: referenceList_001

  - `OfferListResponse.ReferenceList.SeatingChart` (array)

  - `OfferListResponse.ReferenceList.SeatingChart.@type` (string, required)
    Discriminator.
    Enum: "SeatingChart"

  - `OfferListResponse.ReferenceList.SeatingChart.id` (string)
    Internally reference id

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin` (array, required)

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.@type` (string)
    Example: Cabin

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.name` (string, required)
    The name of the cabin
    Example: Economy

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.Layout` (array, required)

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.Layout.value` (string)

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.Layout.position` (array, required)

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.Layout.startRow` (integer, required)
    Start row for this Cabin Layout

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.Layout.endRow` (integer, required)
    End row for this Cabin Layout

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.Row` (array, required)

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.Row.@type` (string)
    Example: Row

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.Row.label` (string)
    The identifier for the row
    Example: 78

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.Row.Space` (array, required)

  - `OfferListResponse.ReferenceList.SeatingChart.Cabin.Row.Characteristic` (array)

  - `OfferListResponse.ReferenceList.Flight` (array, required)

  - `OfferListResponse.ReferenceList.Flight.@type` (string, required)
    Discriminator. Child classes Flight and FlightDetail.
    Enum: "Flight"

  - `OfferListResponse.ReferenceList.Flight.id` (string)
    Local id within a given message to support referencing this object - an internal flight identifier.
    Example: 126

  - `OfferListResponse.ReferenceList.Flight.FlightRef` (string)
    Reference id that corresponds to the flight 'id' in ReferenceListFlight.Flight.
    Example: s1

  - `OfferListResponse.ReferenceList.Flight.distance` (integer)
    Distance covered by the flight.
    Example: 6574

  - `OfferListResponse.ReferenceList.Flight.stops` (integer)
    Number of stops
    Example: 2

  - `OfferListResponse.ReferenceList.Flight.duration` (string)
    Elapsed flight time.
Represented in hours (H) and minutes (M) OR the format PT{x}H{x}M, in which P is the duration designator, T is the time designator, {x}H is the number of hours for the connection, and {x}H is the number of minutes for the connection.
    Example: PT1H40M

  - `OfferListResponse.ReferenceList.Flight.carrier` (string, required)
    The airline code.
    Example: BA

  - `OfferListResponse.ReferenceList.Flight.number` (string, required)
    The marketing carrier flight number.
    Example: 98

  - `OfferListResponse.ReferenceList.Flight.operatingCarrier` (string)
    The operating airline IATA code. Shown in codeshare situations when the operating carrier is different to the marketing carrier.
    Example: BA

  - `OfferListResponse.ReferenceList.Flight.operatingCarrierName` (string)
    Name of the marketing operating carrier.
    Example: Liberty Aerospace

  - `OfferListResponse.ReferenceList.Flight.operatingCarrierNumber` (string)
    Operating airline flight number. If there is no operating carrier number, then CO2 emission estimates for operating carriers is not supported. GDS only; not returned for NDC. Returned only in Search response.
    Example: 091

  - `OfferListResponse.ReferenceList.Flight.equipment` (string)
    Equipment model.  
Note that TRN, TRS, and BUS equipment codes indicate ground transportation.
    Example: 777

  - `OfferListResponse.ReferenceList.Flight.Departure` (object, required)
    Departure details for a given leg.

  - `OfferListResponse.ReferenceList.Flight.Departure.@type` (string, required)
    Discriminator classes Departure or DepartureDetail
    Enum: "DepartureDetail"

  - `OfferListResponse.ReferenceList.Flight.Departure.location` (string, required)
    IATA code for departure airport or city for this leg of the itinerary.
    Example: AMS

  - `OfferListResponse.ReferenceList.Flight.Departure.date` (string, required)
    Departure date in YYYY-MM-DD format.
    Example: 0011-10-17

  - `OfferListResponse.ReferenceList.Flight.Departure.time` (string, required)
    Departure date in HH:mm:ss (24-hour format).
    Example: 04:45:00

  - `OfferListResponse.ReferenceList.Flight.Departure.terminal` (string)
    Departure terminal, returned when available.
    Example: Terminal 1

  - `OfferListResponse.ReferenceList.Flight.Departure.country` (string)
    Country of to departure or arrival
    Example: US

  - `OfferListResponse.ReferenceList.Flight.Arrival` (object, required)
    Arrival information.

  - `OfferListResponse.ReferenceList.Flight.Arrival.@type` (string, required)
    Discriminator classes Arrival or ArrivalDetail
    Enum: "ArrivalDetail"

  - `OfferListResponse.ReferenceList.Flight.Arrival.location` (string, required)
    IATA code for arrival airport or city for this leg of the itinerary.
    Example: MAD

  - `OfferListResponse.ReferenceList.Flight.Arrival.date` (string, required)
    Arrival date in YYYY-MM-DD format.
    Example: 0011-10-17

  - `OfferListResponse.ReferenceList.Flight.Arrival.time` (string)
    Arrival date in HH:mm:ss (24-hour format).
    Example: 04:45:00

  - `OfferListResponse.ReferenceList.Flight.Arrival.terminal` (string)
    Arrival terminal, returned when available.
    Example: Terminal 1

  - `OfferListResponse.ReferenceList.Flight.Arrival.country` (string)
    Country of to departure or arrival
    Example: US

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop` (array)
    GDS only; not supported for NDC.  
Returned if the flight has a technical stop but does not incur a change in flight number.

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.value` (string)
    The IATA airport code for the airport where the intermediate stop occurs.

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.arrivalFlightDuration` (string)
    Duration in hours and minutes of the flight arriving at the intermediate stop. ISO 8601 format
    Example: PT2H35M

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.departureFlightDuration` (string)
    Duration in hours and minutes of the flight departing the intermediate stop. ISO 8601 format
    Example: PT1H35M

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.duration` (string)
    Duration in hours and minutes between the arrival and departure at the intermediate stop. ISO 8601 format
    Example: PT1H35M

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.equipment` (string)
    Equipment model, if there is a change of equipment during the stop.
    Example: 777

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.arrivalDate` (string)
    The local date the aircraft arrives at the intermediate stop
    Example: 2026-04-30

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.departureDate` (string)
    The local date the aircraft departs from the intermediate stop
    Example: 2026-04-30

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.arrivalTime` (string)
    The local time the aircraft arrives at the intermediate stop
    Example: 68400

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.departurelTime` (string)
    The local time the aircraft departs from the intermediate stop
    Example: 72000

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.arrivalTerminal` (string)
    Arrival terminal of the intermediate stop airport
    Example: Terminal2

  - `OfferListResponse.ReferenceList.Flight.IntermediateStop.departureTerminal` (string)
    Departure terminal of the intermediate stop airport
    Example: Terminal4

  - `OfferListResponse.ReferenceList.Flight.subjectToGovernmentApprovalInd` (boolean)
    GDS only, not supported for NDC.
- If true: the airline has filed in its schedule that availability for a specific flight is subject to government approval. Returned only in the Air Search API response.
    Example: true

  - `OfferListResponse.ReferenceList.Amenity` (array, required)
    One instance for each specific amenity.

  - `OfferListResponse.ReferenceList.Amenity.@type` (string, required)
    Discriminator. No child classes.
    Example: Amenity

  - `OfferListResponse.ReferenceList.Amenity.id` (string, required)
    A unique Travelport-assigned amenity id used for cross-referencing by each flight with this amenity.
    Example: amenity_001

  - `OfferListResponse.ReferenceList.Amenity.Category` (string, required)
    Flight amenity categories may include the following data as provided by ATPCO.
- Aircraft: cabin pressure, model and type.
- Beverage: alcoholic and non-alcoholic beverages and whether available for a fee or free; highlights premium beverages in business/first.
- Entertainment: passenger entertainment options.
- Flight: airline flight schedules and equipment types with the associated amenities ID for each carrier.
- Food: food per flight and flight cabin and whether available for a fee or free; food is classified as breakfast, lunch, dinner, snacks, and light meals, and as premium when available in business/first.
- Layout: seating layout such as classic layouts to premium cabin configurations.
- Power: availability of AC power outlets, USB ports, or both.
- Seat: physical seat type for every sub fleet in every cabin of the aircraft, including legroom, pitch, width, flatness and type. Note that seat metrics are returned in centimeters because the default language is English.
- WiFi: availability, type, coverage, rollout, performance, and whether available free or for a fee.
    Example: Entertainment

  - `OfferListResponse.ReferenceList.Amenity.Text` (object)
    A free text description of the amenity.

  - `OfferListResponse.ReferenceList.Amenity.Text.value` (string)
    A short free text description.

  - `OfferListResponse.ReferenceList.Amenity.Text.language` (string)
    The language the text is provided in. ISO639 format.
    Example: EN

  - `OfferListResponse.ReferenceList.Product` (array)

  - `OfferListResponse.ReferenceList.Product.@type` (string, required)
    Discriminator.
- Air Search child classes are ProductAir and ProductAncillary.
- Exchange Search child class is ProductAir.
- Ancillary Search child class is ProductAncillary.
- Seat Map child class is ProductSeatAvailability.
- Air Price child classes are ProductAir and ProductAncillary.
- Hotel Availability child classes are ProductHospitality and ProductHospitalityOffer.
- Hotel Rules and HotelReservation child classes are ProductHospitality.
- All Vehicle APIs child classes are ProductVehicle and ProductAncillaryVehicle.
- Reservation and Reservation Workbench child classes are ProductAir, ProductAncillary, ProductHospitality, ProductVehicle, and ProductAncillaryVehicle.
    Enum: "Product"

  - `OfferListResponse.ReferenceList.Product.id` (string)
    Local id within a given message to support referencing this object.
    Example: product_1

  - `OfferListResponse.ReferenceList.Product.productRef` (string)
    Reference id that corresponds to the product 'id' in ReferenceListProduct.Product. To find flight details for a product, use the ProductRef id to identify the product in ReferenceListProduct.Product, and use the Flight id's (e.g., s3, s4) to match to flight information in ReferenceListFlight.Flight.
    Example: product_1

  - `OfferListResponse.ReferenceList.Product.Quantity` (integer)
    The quantity of the product. 
For Hotel Create Reservation (Full Payload) request, the number of rooms requested; 1-9 inclusive supported. If not provided, default is 1. For Hotel responses, the number of rooms currently available matching this rate.
In Air Search quantity represents the number of seats available for that Product. If the Product has connecting flights, Quantity returns the lowest number available. For example, if the first flight has 9 seats in Y class and the connecting flight has 4 seats in Y class, Quantity returns a value of 4.
    Example: 2

  - `OfferListResponse.ReferenceList.Traveler` (array)

  - `OfferListResponse.ReferenceList.Traveler.@type` (string, required)
    Discriminator classes TravelerID or Traveler
    Enum: "Traveler"

  - `OfferListResponse.ReferenceList.Traveler.id` (string)
    Send value of travelerRefId_1 for the first traveler, then increment for each additional traveler (e.g., travelerRefId_2).
Traveler/id is only mandatory when referenced elsewhere in the request, such as in SpecialService and PrimaryContact (TravelerIdentifier/Identifier/value).

  - `OfferListResponse.ReferenceList.Traveler.TravelerRef` (string)

  - `OfferListResponse.ReferenceList.Traveler.birthDate` (string)
    Date of birth in YYYY-MM-DD format.
The TripServices APIs require this object only for infant and child PTC types (e.g., INF, INS, CHD, UNN).
When sending [minimum secure flight information](https://developer.travelport.com/docs/flights/guides/booking-and-reservations/remarks-and-service-requests#minimum-secure-flight-information-ssr-docs), which is required by some carriers, this object is required for all PTCs.
    Example: 2021-06-05

  - `OfferListResponse.ReferenceList.Traveler.gender` (string)
    Gender Type Male, Female etc.
When sending [minimum secure flight information](https://developer.travelport.com/docs/flights/guides/booking-and-reservations/remarks-and-service-requests#minimum-secure-flight-information-ssr-docs) in the Traveler object, which is required by some carriers, this object is required for all PTCs.
This field is not used by Hotel APIs and will be ignored.
    Enum: "Male", "Female", "Unknown", "Undisclosed"

  - `OfferListResponse.ReferenceList.Traveler.PersonName` (object, required)
    Travelport+ limits the combination of Given and Surname to 22 characters. Given name must have at least one character. Any PersonName exceeding 22 characters is truncated in the response.

  - `OfferListResponse.ReferenceList.Traveler.PersonName.@type` (string, required)
    Discriminator classes PersonName or PersonNameDetail
    Enum: "PersonNameDetail"

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Prefix` (string)
    Salutation of honorific (e.g. Mr., Mrs., Ms., Miss, Dr.)
    Example: Mr

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Given` (string)
    Traveler first or given name.
    Example: John

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Middle` (string)
    Traveler middle name.
    Example: Erick

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Surname` (string, required)
    Traveler last name or surname.
    Example: Smith

  - `OfferListResponse.ReferenceList.Traveler.PersonName.personNameType` (string)
    OTA Code
    Enum: "Former", "Nickname", "Alternate", "Maiden"

  - `OfferListResponse.ReferenceList.Traveler.PersonName.language` (string)
    'ISO639 code of the language the name is represented
    Example: EN

  - `OfferListResponse.ReferenceList.Traveler.PersonName.SurnamePrefix` (string)
    The surname prefix
    Example: Von

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Suffix` (string)
    Traveler name suffix such as Jr. or Sr.
    Example: Jr.

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Title` (string)
    Degree or honors
    Example: DR

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Privacy` (object)
    Confidential details for marketing purpose

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Privacy.id` (string)
    Optional internally referenced id
    Example: 2

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Privacy.shareMarketing` (string)
    Used to indicate marketing preferences, Yes, No, Inherit
    Enum: "Yes", "No", "Inherit"

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Privacy.optInStatus` (string)
    Used to indicate marketing preferences, OptIn, OptOut
    Enum: "OptedIn", "OptedOut", "Unknown"

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Privacy.optInDate` (string)
    The datetime of receiving the opt in notice
    Example: 2026-08-07T12:12:00Z

  - `OfferListResponse.ReferenceList.Traveler.PersonName.Privacy.optOutDate` (string)
    The datetime the opt out notice was received
    Example: 2026-08-07T12:12:00Z

  - `OfferListResponse.ReferenceList.Traveler.PersonName.defaultInd` (boolean)
    If true, this is the default or primary name within a collection of names.
    Example: true

  - `OfferListResponse.ReferenceList.Traveler.Address` (array)

  - `OfferListResponse.ReferenceList.Traveler.Address.@type` (string, required)
    Discriminator classes Address or AddressDetail
    Enum: "AddressDetail", "PropertyAddress"

  - `OfferListResponse.ReferenceList.Traveler.Address.id` (string)
    unique address id
    Example: Address_1

  - `OfferListResponse.ReferenceList.Traveler.Address.BldgRoom` (object)
    Address with building and room number

  - `OfferListResponse.ReferenceList.Traveler.Address.BldgRoom.value` (string)
    Example: Moore House

  - `OfferListResponse.ReferenceList.Traveler.Address.BldgRoom.buldingInd` (boolean)
    When true, the information is a building name. When false, it is an apartment or room #
    Example: true

  - `OfferListResponse.ReferenceList.Traveler.Address.Number` (object)
    The street number alone is the numerical number that precedes the street name in the address.

  - `OfferListResponse.ReferenceList.Traveler.Address.Number.value` (string)
    Street number value.
    Example: 23B

  - `OfferListResponse.ReferenceList.Traveler.Address.Number.streetNmbrSuffix` (string)
    Street Number Suffix
    Example: B

  - `OfferListResponse.ReferenceList.Traveler.Address.Number.streetDirection` (string)
    Direction of the Street
    Example: NW

  - `OfferListResponse.ReferenceList.Traveler.Address.Number.ruralRouteNmbr` (string)
    RuralRoute Number
    Example: 76

  - `OfferListResponse.ReferenceList.Traveler.Address.Number.po_Box` (string)
    PO Box Number
    Example: 1001

  - `OfferListResponse.ReferenceList.Traveler.Address.Street` (string)
    Street name. May also contain the street number when the Number element is missing.
    Example: ABC Street

  - `OfferListResponse.ReferenceList.Traveler.Address.AddressLine` (array)
    Property street address. Used in place of Street and Number. Each element of the array represents an address line.

  - `OfferListResponse.ReferenceList.Traveler.Address.City` (string, required)
    Full name of the city, town, or postal station (i.e., a postal service territory, often used in a military address).
    Example: Dublin

  - `OfferListResponse.ReferenceList.Traveler.Address.County` (string)
    County or Region Name.
    Example: Berkshire

  - `OfferListResponse.ReferenceList.Traveler.Address.StateProv` (object)
    The standard code or abbreviation for the state, province, or region. May also include full length name.

  - `OfferListResponse.ReferenceList.Traveler.Address.StateProv.value` (string)
    State, province, or region code needed to identify location (typically two characters).
    Example: CA

  - `OfferListResponse.ReferenceList.Traveler.Address.StateProv.name` (string)
    State, province, or region name needed to identify location.
    Example: California

  - `OfferListResponse.ReferenceList.Traveler.Address.Country` (object)
    Contains the information needed to identify a country.

  - `OfferListResponse.ReferenceList.Traveler.Address.Country.value` (string)
    The ISO 3166 code for the property's address.
    Example: US

  - `OfferListResponse.ReferenceList.Traveler.Address.Country.id` (string)
    Custom user-assigned identifier for the country.
    Example: 23

  - `OfferListResponse.ReferenceList.Traveler.Address.Country.name` (string)
    The full name of the country for the property's address.
    Example: United States

  - `OfferListResponse.ReferenceList.Traveler.Address.Country.codeContext` (string)
    The source of a code, such as the organization that provided the id number
    Example: IATA

  - `OfferListResponse.ReferenceList.Traveler.Address.PostalCode` (string)
    Postal code for the address.
    Example: Sl6 1AB

  - `OfferListResponse.ReferenceList.Traveler.Address.Addressee` (string)
    The name of the company or person to be addressed
    Example: ACME INC

  - `OfferListResponse.ReferenceList.Traveler.Address.role` (string)
    Defines the type of location the address is assigned to. For TravelAgency address leave blank or use "Other".
    Enum: "Home", "Business", "Mailing", "Delivery", "Destination", "Other", "Billing"

  - `OfferListResponse.ReferenceList.Traveler.Address.addressType` (string)
    OTA code for address type
    Example: CLT

  - `OfferListResponse.ReferenceList.Traveler.Address.use` (string)
    OTA code for address use
    Example: AUT

  - `OfferListResponse.ReferenceList.Traveler.Address.Comment` (object)
    Textual information.

  - `OfferListResponse.ReferenceList.Traveler.Address.Comment.value` (string)
    Actual text.
May be restricted based on the type of comment. Ex:
- Notepad remarks: limited to 87 characters.
- Traveler name remarks: limited to 33 characters, only spaces and hyphens allowed for special characters.
    Example: Additional comments

  - `OfferListResponse.ReferenceList.Traveler.Address.Comment.id` (string)
    Local identifier within a given message for this object.
    Example: comment_1

  - `OfferListResponse.ReferenceList.Traveler.Address.Comment.name` (string)
    Title of comment or type of remark.
    Example: Comment name

  - `OfferListResponse.ReferenceList.Traveler.Address.Comment.language` (string)
    Language code using ISO-639 standard
    Example: EN

  - `OfferListResponse.ReferenceList.Traveler.Address.Priority` (integer)
    The priority ranking within the group
    Example: 1

  - `OfferListResponse.ReferenceList.Traveler.Address.validInd` (boolean)
    If true, this is a valid and complete mailing address that has been verified through an address verification service or previously mailed materials have not been returned.
    Example: false

  - `OfferListResponse.ReferenceList.Traveler.Address.provisionedInd` (boolean)
    If true, this address came into the system through provisioning
    Example: false

  - `OfferListResponse.ReferenceList.Traveler.Telephone` (array)

  - `OfferListResponse.ReferenceList.Traveler.Telephone.@type` (string, required)
    Discriminator classes Telephone or TelephoneDetail
    Enum: "TelephoneDetail"

  - `OfferListResponse.ReferenceList.Traveler.Telephone.countryAccessCode` (string)
    Phone country code
    Example: 1

  - `OfferListResponse.ReferenceList.Traveler.Telephone.areaCityCode` (string)
    Phone local area code
    Example: 972

  - `OfferListResponse.ReferenceList.Traveler.Telephone.phoneNumber` (string, required)
    Mobile/Telephone Number. Accepted characters are numeric, dash, space, and period.
    Example: 972-000-787

  - `OfferListResponse.ReferenceList.Traveler.Telephone.extension` (string)
    Telephone extension number
    Example: 234

  - `OfferListResponse.ReferenceList.Traveler.Telephone.id` (string)
    Optional custom user-assigned identifier for a phone number.
    Example: 3

  - `OfferListResponse.ReferenceList.Traveler.Telephone.cityCode` (string)
    IATA city code if referenced by phone number.
    Example: DEN

  - `OfferListResponse.ReferenceList.Traveler.Telephone.role` (string)
    Defines the type of location the Telephone is assigned to. For Travel Agency telephone select "Other" or leave blank.
    Enum: "Mobile", "Home", "Work", "Office", "Fax", "Other"

  - `OfferListResponse.ReferenceList.Traveler.Telephone.phoneLocationType` (string)
    Location of the phone
    Example: Agency

  - `OfferListResponse.ReferenceList.Traveler.Telephone.phoneTechType` (string)
    Indicates the type of technology associated with the telephone number
    Example: Voice

  - `OfferListResponse.ReferenceList.Traveler.Telephone.phoneUseType` (string)
    Agency code for how phone is used (e.g., Home, Business, Emergency Contact, Travel Arranger, Day, Evening).
    Example: Home

  - `OfferListResponse.ReferenceList.Traveler.Telephone.pin` (string)
    Additional codes used for telephone
    Example: 3456

  - `OfferListResponse.ReferenceList.Traveler.Telephone.priority` (integer)
    Priority
    Example: 1

  - `OfferListResponse.ReferenceList.Traveler.Telephone.defaultInd` (boolean)
    When true, indicates a default value should be used.
    Example: true

  - `OfferListResponse.ReferenceList.Traveler.Telephone.provisionedInd` (boolean)
    true indicates this phone number was created through provisioned
    Example: false

  - `OfferListResponse.ReferenceList.Traveler.Email` (array)
    For a reservation Retrieve response, all email addresses are associated with the first traveler on the reservation for GDS. NDC supports contact information for each traveler on the reservation.

  - `OfferListResponse.ReferenceList.Traveler.Email.value` (string)
    The email address.
    Example: exampledomain@example.com

  - `OfferListResponse.ReferenceList.Traveler.Email.id` (string)
    Electronic email addresses, in IETF specified format.
    Example: email_1

  - `OfferListResponse.ReferenceList.Traveler.Email.emailType` (string)
    Use email type to specify if the email is to be sent "TO" or sent "FROM"
    Example: FROM

  - `OfferListResponse.ReferenceList.Traveler.Email.comment` (string)
    Any freeform note for the email, such as its purpose.
    Example: work email

  - `OfferListResponse.ReferenceList.Traveler.Email.preferredFormat` (string)
    Mime media type
    Example: text/html

  - `OfferListResponse.ReferenceList.Traveler.Email.optInDate` (string)
    The datetime of receiving the opt in notice
    Example: 2026-03-03T11:11:00Z

  - `OfferListResponse.ReferenceList.Traveler.Email.optOutDate` (string)
    The datetime the opt out notice was received
    Example: 2026-03-03T11:11:00Z

[...]
